/******************************************************************************
 *
 * Copyright (C) 1997-2019 by Dimitri van Heesch.
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation under the terms of the GNU General Public License is hereby
 * granted. No representations are made about the suitability of this software
 * for any purpose. It is provided "as is" without express or implied warranty.
 * See the GNU General Public License for more details.
 *
 */

#ifndef INPUTSTRLIST_H
#define INPUTSTRLIST_H

#include "input.h"

#include <QObject>
#include <OStringList>

class QLabel;
class QLineEdit;
class OPushButton;
class QListWidget;
class QGridLayout;
class QAction;

class InputStrList : public QObject, public Input
{
  Q_OBJECT

  public:
    enum ListMode { ListString  = 0,
                    ListFile    = 1,
                    ListDir     = 2,
                    ListFileDir = ListFile | ListDir
                  };

    InputStrList( QGridLayout *layout,int &row,
                  const OString &id, const OStringList &sl,
                  ListMode v, const OString &docs);
    void setValue(const OStringList &sl);

    QVariant &value();
    void update();
    Kind kind() const { return StrList; }
    OString docs() const { return m_docs; }
    OString id() const { return m_id; }
    OString templateDocs() const { return m_tdocs; }
    void addDependency(Input *) { Q_ASSERT(false); }
    void setEnabled(bool);
    void updateDependencies() {}
    bool isDefault();
    void writeValue(QGGextStream &t,TextCodecAdapter *codec,bool convert);
    void setTemplateDocs(const OString &docs) { m_tdocs = docs; }
    bool isEmpty();

  public slots:
    void reset();

  signals:
    void changed();
    void showHelp(Input *);

  private slots:
    void addString();
    void delString();
    void updateString();
    void selectText(const OString &s);
    void browseFiles();
    void browseDir();
    void help();

  private:
    void updateDefault();
    QLabel       *m_lab;
    QLineEdit    *m_le;
    QAction      *m_add;
    QAction      *m_del;
    QAction      *m_upd;
    QAction      *m_brFile;
    QAction      *m_brDir;
    QListWidget  *m_lb;
    OStringList   m_default;
    OStringList   m_strList;
    QVariant      m_value;
    OString       m_docs;
    OString       m_id;
    OString       m_tdocs;
};

#endif
